#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <conio.h>
#include <mem.h>
#include <dos.h>
#include <alloc.h>
#include "graficos.h"
#include "teclado.h"

typedef struct PALETA
{
 unsigned char rojo;
 unsigned char verde;
 unsigned char azul;
} paleta;

void definir_paleta (paleta *);
void activar_paleta (paleta *);
void rotar_paleta (paleta *);
void interferencias (int, int, int, int);
void paleta_nubes(paleta *);
void nubes(int);
void ajustar(int, int, int, int, int, int, int);
void dividir(int, int, int, int, int);


int xdots=320, ydots=200,colores=256;

void main (void)
{
 int i,j,n;
 paleta *pal;

 if ((pal=(paleta *)calloc(256*3, sizeof(char)))!=NULL)
 {
  MODO_VIDEO (VGA);
  RELLENA_PANTALLA (0);
  randomize();
  n = random(250)+50;
  definir_paleta (pal);
  activar_paleta(pal);
  interferencias(-32, 32, -24, 24);

  rotar_paleta(pal);

  MODO_VIDEO(MSDOS);
  MODO_VIDEO(VGA);
  paleta_nubes(pal);
  activar_paleta(pal);
  nubes(n);

  MODO_VIDEO (MSDOS);
 }
 else
  printf ("\n\n No hay memoria suficiente.");
}

void activar_paleta (paleta *pal)
{
 struct REGPACK preg;
 preg.r_ax=0x1012;
 preg.r_bx=0x00;
 preg.r_cx=0xff;
 preg.r_es=FP_SEG(pal);
 preg.r_dx=FP_OFF(pal);
 intr(0x10,&preg);
}

void definir_paleta (paleta *pal)
{
 int i;
 paleta c1={63,0,0};
 paleta c2={0,63,63};
 paleta c3={63,63,0};
 pal->rojo=0;
 pal->verde=0;
 pal->azul=0;
 for(i=1;i<=85;i++)
 {
  (pal+i)->rojo=(i*c2.rojo+(86*i)*c2.rojo)/85;
  (pal+i)->verde=(i*c2.verde+(86*i)*c2.verde)/85;
  (pal+i)->azul=(i*c2.azul+(86*i)*c2.azul)/85;
  (pal+i+85)->rojo=(i*c3.rojo+(86*i)*c3.rojo)/85;
  (pal+i+85)->verde=(i*c3.verde+(86*i)*c3.verde)/85;
  (pal+i+85)->azul=(i*c3.azul+(86*i)*c3.azul)/85;
  (pal+i+170)->rojo=(i*c1.rojo+(86*i)*c1.rojo)/85;
  (pal+i+170)->verde=(i*c1.verde+(86*i)*c1.verde)/85;
  (pal+i+170)->azul=(i*c1.azul+(86*i)*c1.azul)/85;
 }
}

void rotar_paleta(paleta*pal)
{
 paleta temp;
 struct REGPACK preg;
 preg.r_ax=0x1012;
 preg.r_bx=0x00;
 preg.r_cx=0xff;
 preg.r_es=FP_SEG(pal);
 preg.r_dx=FP_OFF(pal);
 while(!kbhit())
 {
  memcpy(&temp,pal+1,sizeof(paleta));
  memcpy(pal+1,pal+2,sizeof(paleta)*254);
  memcpy(pal+255,&temp,sizeof(paleta));
  intr(0x10,&preg);
 }
}

void interferencias (int izquierda, int derecha, int arriba, int abajo)
{
 long t;
 float x,y,i,j;
 for(i=0;i<xdots;i++)
 {
  for(j=0;j<ydots;j++)
  {
   x=izquierda+(derecha-izquierda)*i/xdots;
   y=abajo+(arriba-abajo)*j/ydots;
   t=(x*x+y*y)*colores/4;
   PON_PIXEL(i,j,t%(colores-2)+1);
  }
 }
}

int lee_punto(int x,int y)
{
 union REGS regs;
 regs.h.ah=0x0d;
 regs.h.bh=0;
 regs.x.cx=x;
 regs.x.dx=y;
 int86(0x10,&regs,&regs);
 return(regs.h.al);
}

void paleta_nubes(paleta *pal)
{
 int i;
 pal->rojo=0;
 pal->verde=0;
 pal->azul=0;
 for(i=1;i<colores;i++)
 {
  (pal+i)->rojo=(colores-i)/4;
  (pal+i)->verde=(colores-i)/4;
  (pal+i)->azul=63;
 }
}

void nubes(int dispersion)
{
 randomize();
 PON_PIXEL(0, 0, 1+(((rand()/colores)*(colores-1))>>7));
 PON_PIXEL(xdots-1,0,1+(((rand()/colores)*(colores-1))>>7));
 PON_PIXEL(xdots-1,ydots-1,1+(((rand()/colores)*(colores-1))>>7));
 PON_PIXEL(0,ydots-1,1+(((rand()/colores)*(colores-1))>>7));
 dividir(0,0,xdots-1,ydots-1,dispersion);
}

void dividir(int x1,int y1,int x2,int y2,int dispersion)
{
 int x,y,v;
 if(x2-x1<2 && y2-y1<2)
  return;
 x=(x1+x2)/2;
 y=(y1+y2)/2;
 ajustar(x1,y1,x,y1,x2,y1,dispersion);
 ajustar(x2,y1,x2,y,x2,y2,dispersion);
 ajustar(x1,y2,x,y2,x2,y2,dispersion);
 ajustar(x1,y1,x1,y,x1,y2,dispersion);
 if(lee_punto(x,y)==0)
 {
  v=(lee_punto(x1,y1)+lee_punto(x2,y1)+lee_punto(x2,y2)+lee_punto(x1,y2)+2)/4;
  PON_PIXEL(x,y,v);
 }
 dividir(x1,y1,x,y,dispersion);
 dividir(x,y1,x2,y,dispersion);
 dividir(x,y,x2,y2,dispersion);
 dividir(x1,y,x,y2,dispersion);
}

void ajustar(int xa,int ya,int x,int y,int xb,int yb,int dispersion)
{
 long cp;
 if(lee_punto(x,y)!=0)
  return;
 cp=((long)dispersion)*((rand()-16383));
 cp=cp*(abs(xa-xb)+abs(ya-yb));
 cp=cp>>18;
 cp=((lee_punto(xa,ya)+lee_punto(xb,yb)+1)>>1)+cp;
 if(cp<1)
  cp=1;
 if(cp>=colores-1)
  cp=colores-2;
 PON_PIXEL(x,y,(int)cp);
}