/*
  Proposito: Generar un foco de luz en movimiento en modo texto.

  Compilador: C - 16 bits.

                                              Por:
                                              - * Pedro Anton Alonso * -
                                               aka Crom / Spanish Lords    */
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <dos.h>

#define _MAX_COLUMNAS 135
#define _MAX_FILAS     50
#define _ANCHO_LENTE   14
#define _ALTO_LENTE     7

unsigned char Lente [_ALTO_LENTE][_ANCHO_LENTE] =
                {{0,0,0,0, 8, 8, 8, 8, 8, 8,0,0,0,0},
                 {0,0,8,8, 8, 8, 7, 7, 8, 8,8,8,0,0},
                 {8,8,8,8, 7, 7,15,15, 7, 7,8,8,8,8},
                 {8,8,7,7,15,15,15,15,15,15,7,7,8,8},
                 {8,8,8,8, 7, 7,15,15, 7, 7,8,8,8,8},
                 {0,0,8,8, 8, 8, 7, 7, 8, 8,8,8,0,0},
                 {0,0,0,0, 8, 8, 8, 8, 8, 8,0,0,0,0}};

unsigned char  NumFilas;
unsigned char  NumColumnas;
unsigned char *pMemToCopy;
int            Cnt;
unsigned char  PosX,PosY;
char           IncX,IncY;
unsigned char __far *ptrVideo;

void LimpiaAtributos();
void HazLuz();

//
//  The  M A I N * -
//
void main (void)
{
  unsigned char __far *ptrBIOS = (unsigned char __far *)MK_FP (0x0040,0);

  ptrVideo= (unsigned char __far *)MK_FP (0xB800,0);
  NumColumnas=ptrBIOS [0x004A];
  NumFilas   =ptrBIOS [0x0084]+1;
  printf   ("Resolucin actual: %i x %i\n",NumColumnas,NumFilas);
  pMemToCopy = (unsigned char *)malloc (NumFilas*NumColumnas*2);
  for (Cnt=0;Cnt<NumFilas*NumColumnas*2;Cnt++) pMemToCopy[Cnt]=ptrVideo[Cnt];
  LimpiaAtributos();
  PosX = rand()%(NumColumnas-20);
  PosY = rand()%(NumFilas-20);
  IncX = 1;
  IncY = 1;
  do
  {
    for (Cnt=0;Cnt<3;Cnt++) // 3 retrazos: 22.5 fps
    {
      while (!((inp(0x3DA)&8) >0));
      while (!((inp(0x3DA)&8)==0));
    }
    HazLuz();
  } while (!kbhit());
  for (Cnt=0;Cnt<NumFilas*NumColumnas*2;Cnt++) ptrVideo[Cnt]=pMemToCopy[Cnt];
  free (pMemToCopy);
};
//
// FUNCTIONS
//
void LimpiaAtributos()
{
  int Cnt;

   Cnt=1;
  do
  {
    ptrVideo [Cnt]=0;
    Cnt+=2;
  } while (Cnt<NumFilas*NumColumnas*2);
};

void HazLuz()
{
  unsigned int  Desde;
  unsigned char CntX;
  unsigned char CntY;

  LimpiaAtributos();
  for (CntY=0;CntY<7;CntY++)
    for (CntX=0;CntX<14;CntX++)
      ptrVideo[((((PosY+CntY)*NumColumnas)+PosX+CntX)<<1)+1]=Lente[CntY][CntX];
  if (IncX==1)
  {
    PosX++;
    if (PosX>=NumColumnas-_ANCHO_LENTE) IncX=0;
  }
  else
  {
    PosX--;
    if (PosX<=0) IncX=1;
  };
  if (IncY==1)
  {
    PosY++;
    if (PosY>=NumFilas-_ALTO_LENTE) IncY=0;
  }
  else
  {
    PosY--;
    if (PosY<=0) IncY=1;
  };
};










